/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 339 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_HR = 25,                      /* T_HR  */
  YYSYMBOL_T_HC = 26,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 27,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 28,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 29,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 30,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 31,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 32,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 33,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 34,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 35,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 36,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 37,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 38,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 39,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 40,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 41,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 42,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 43,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 44,                      /* T_SY  */
  YYSYMBOL_T_SS = 45,                      /* T_SS  */
  YYSYMBOL_T_JP = 46,                      /* T_JP  */
  YYSYMBOL_T_SAT = 47,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 48,                     /* T_RPT  */
  YYSYMBOL_T_UL = 49,                      /* T_UL  */
  YYSYMBOL_T_NOP = 50,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 51,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 52,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 53,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 54,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 55,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 56,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 57,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 58,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 59,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 60,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 61,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 62,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 63,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 64,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 65,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 66,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 67,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 68,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 69,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 70,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 71,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 72,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 73,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 74,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 75,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 76,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 77,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 78,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 79,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 80,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 81,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 82,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 83,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 84,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 85,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 86,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 87,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 88,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 89,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 90,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 91,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 92,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 93,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 94,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 95,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 96,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 97,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 98,              /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 99,               /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 100,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 101,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 102,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 103,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 104,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 105,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 106,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 107,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 108,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 109,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 110,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 111,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 112,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 113,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 114,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 115,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 116,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 117,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 118,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 119,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 120,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 121,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 122,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 123,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 124,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 125,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 126,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 127,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 128,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 129,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 130,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 131,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 132,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 133,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 134,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 135,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 136,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 137,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 138,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 139,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 140,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 141,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 142,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 143,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 144,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 145,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 146,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 147,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 148,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 149,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 150,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 151,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 152,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 153,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 154,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 155,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 156,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 157,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 158,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 159,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 160,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 161,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 162,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 163,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 164,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 165,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 166,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 167,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 168,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 169,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 170,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 171,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 172,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 173,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 174,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 175,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 176,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 177,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 178,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 179,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 180,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 181,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 182,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 183,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 184,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 185,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 186,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 187,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 188,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 189,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 190,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 191,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 192,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 193,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 194,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 195,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 196,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 197,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 198,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 199,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 200,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 201,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 202,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 203,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 204,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 205,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 206,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 207,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 208,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 209,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 210,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 211,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 212,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 213,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 214,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 215,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 216,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 217,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 218,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 219,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 220,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 221,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 222,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 223,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 224,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 225,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 226,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 227,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 228,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 229,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 230,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 231,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 232,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 233,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 234,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 235,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 236,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 237,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 238,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 239,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 240,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 241,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 242,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 243,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 244,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 245,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 246,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 247,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 248,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 249,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 250,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 251,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 252,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 253,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 254,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 255,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 256,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 257,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 258,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 259,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 260,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 261,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 262,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 263,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 264,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 265,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 266,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 267,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 268,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 269,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 270,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 271,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 272,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 273,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 274,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 275,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 276,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 277,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_BAR = 278,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 279,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 280,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 281,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 282,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 283,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 284,               /* T_OP_DCFLU  */
  YYSYMBOL_T_RAW = 285,                    /* T_RAW  */
  YYSYMBOL_T_TYPE_F16 = 286,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 287,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 288,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 289,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 290,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 291,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 292,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 293,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 294,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 295,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 296,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 297,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 298,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 299,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 300,                     /* T_1D  */
  YYSYMBOL_T_2D = 301,                     /* T_2D  */
  YYSYMBOL_T_3D = 302,                     /* T_3D  */
  YYSYMBOL_T_4D = 303,                     /* T_4D  */
  YYSYMBOL_T_LT = 304,                     /* T_LT  */
  YYSYMBOL_T_LE = 305,                     /* T_LE  */
  YYSYMBOL_T_GT = 306,                     /* T_GT  */
  YYSYMBOL_T_GE = 307,                     /* T_GE  */
  YYSYMBOL_T_EQ = 308,                     /* T_EQ  */
  YYSYMBOL_T_NE = 309,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 310,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 311,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 312,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 313,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 314,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 315,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 316,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 317,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 318,                    /* T_NAN  */
  YYSYMBOL_T_INF = 319,                    /* T_INF  */
  YYSYMBOL_T_A0 = 320,                     /* T_A0  */
  YYSYMBOL_T_A1 = 321,                     /* T_A1  */
  YYSYMBOL_T_P0 = 322,                     /* T_P0  */
  YYSYMBOL_T_W = 323,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 324,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_325_ = 325,                     /* '-'  */
  YYSYMBOL_326_ = 326,                     /* ','  */
  YYSYMBOL_327_ = 327,                     /* '('  */
  YYSYMBOL_328_ = 328,                     /* ')'  */
  YYSYMBOL_329_ = 329,                     /* '='  */
  YYSYMBOL_330_ = 330,                     /* ':'  */
  YYSYMBOL_331_ = 331,                     /* '!'  */
  YYSYMBOL_332_ = 332,                     /* '#'  */
  YYSYMBOL_333_ = 333,                     /* '.'  */
  YYSYMBOL_334_a_ = 334,                   /* 'a'  */
  YYSYMBOL_335_o_ = 335,                   /* 'o'  */
  YYSYMBOL_336_p_ = 336,                   /* 'p'  */
  YYSYMBOL_337_s_ = 337,                   /* 's'  */
  YYSYMBOL_338_ = 338,                     /* '+'  */
  YYSYMBOL_339_ = 339,                     /* '<'  */
  YYSYMBOL_340_g_ = 340,                   /* 'g'  */
  YYSYMBOL_341_ = 341,                     /* '['  */
  YYSYMBOL_342_ = 342,                     /* ']'  */
  YYSYMBOL_343_l_ = 343,                   /* 'l'  */
  YYSYMBOL_344_k_ = 344,                   /* 'k'  */
  YYSYMBOL_345_c_ = 345,                   /* 'c'  */
  YYSYMBOL_346_w_ = 346,                   /* 'w'  */
  YYSYMBOL_347_r_ = 347,                   /* 'r'  */
  YYSYMBOL_348_ = 348,                     /* '>'  */
  YYSYMBOL_349_h_ = 349,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 350,                 /* $accept  */
  YYSYMBOL_shader = 351,                   /* shader  */
  YYSYMBOL_352_1 = 352,                    /* $@1  */
  YYSYMBOL_headers = 353,                  /* headers  */
  YYSYMBOL_header = 354,                   /* header  */
  YYSYMBOL_const_val = 355,                /* const_val  */
  YYSYMBOL_localsize_header = 356,         /* localsize_header  */
  YYSYMBOL_const_header = 357,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 358,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 359,               /* buf_header  */
  YYSYMBOL_360_2 = 360,                    /* $@2  */
  YYSYMBOL_invocationid_header = 361,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 362,              /* wgid_header  */
  YYSYMBOL_numwg_header = 363,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 364,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 365,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 366,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 367,                /* in_header  */
  YYSYMBOL_out_header = 368,               /* out_header  */
  YYSYMBOL_tex_header = 369,               /* tex_header  */
  YYSYMBOL_iflag = 370,                    /* iflag  */
  YYSYMBOL_iflags = 371,                   /* iflags  */
  YYSYMBOL_instrs = 372,                   /* instrs  */
  YYSYMBOL_instr = 373,                    /* instr  */
  YYSYMBOL_label = 374,                    /* label  */
  YYSYMBOL_cat0_src1 = 375,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 376,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 377,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 378,               /* cat0_instr  */
  YYSYMBOL_379_3 = 379,                    /* $@3  */
  YYSYMBOL_380_4 = 380,                    /* $@4  */
  YYSYMBOL_381_5 = 381,                    /* $@5  */
  YYSYMBOL_382_6 = 382,                    /* $@6  */
  YYSYMBOL_383_7 = 383,                    /* $@7  */
  YYSYMBOL_384_8 = 384,                    /* $@8  */
  YYSYMBOL_385_9 = 385,                    /* $@9  */
  YYSYMBOL_386_10 = 386,                   /* $@10  */
  YYSYMBOL_387_11 = 387,                   /* $@11  */
  YYSYMBOL_388_12 = 388,                   /* $@12  */
  YYSYMBOL_389_13 = 389,                   /* $@13  */
  YYSYMBOL_390_14 = 390,                   /* $@14  */
  YYSYMBOL_391_15 = 391,                   /* $@15  */
  YYSYMBOL_392_16 = 392,                   /* $@16  */
  YYSYMBOL_393_17 = 393,                   /* $@17  */
  YYSYMBOL_394_18 = 394,                   /* $@18  */
  YYSYMBOL_cat1_opc = 395,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 396,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 397,              /* cat1_movmsk  */
  YYSYMBOL_398_19 = 398,                   /* $@19  */
  YYSYMBOL_cat1_mova1 = 399,               /* cat1_mova1  */
  YYSYMBOL_400_20 = 400,                   /* $@20  */
  YYSYMBOL_cat1_mova = 401,                /* cat1_mova  */
  YYSYMBOL_402_21 = 402,                   /* $@21  */
  YYSYMBOL_cat1_swz = 403,                 /* cat1_swz  */
  YYSYMBOL_404_22 = 404,                   /* $@22  */
  YYSYMBOL_cat1_gat = 405,                 /* cat1_gat  */
  YYSYMBOL_406_23 = 406,                   /* $@23  */
  YYSYMBOL_cat1_sct = 407,                 /* cat1_sct  */
  YYSYMBOL_408_24 = 408,                   /* $@24  */
  YYSYMBOL_cat1_instr = 409,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 410,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 411,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 412,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 413,                     /* cond  */
  YYSYMBOL_cat2_instr = 414,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 415,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 416,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 417,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 418,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 419,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 420,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 421,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 422,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 423,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 424,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 425,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 426,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 427,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 428,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 429,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 430,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 431,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 432,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 433,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 434,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 435,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 436,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 437,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 438,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 439,               /* cat6_immed  */
  YYSYMBOL_cat6_stg_ldg_a6xx_offset = 440, /* cat6_stg_ldg_a6xx_offset  */
  YYSYMBOL_cat6_load = 441,                /* cat6_load  */
  YYSYMBOL_442_25 = 442,                   /* $@25  */
  YYSYMBOL_443_26 = 443,                   /* $@26  */
  YYSYMBOL_444_27 = 444,                   /* $@27  */
  YYSYMBOL_445_28 = 445,                   /* $@28  */
  YYSYMBOL_446_29 = 446,                   /* $@29  */
  YYSYMBOL_447_30 = 447,                   /* $@30  */
  YYSYMBOL_448_31 = 448,                   /* $@31  */
  YYSYMBOL_cat6_store = 449,               /* cat6_store  */
  YYSYMBOL_450_32 = 450,                   /* $@32  */
  YYSYMBOL_451_33 = 451,                   /* $@33  */
  YYSYMBOL_452_34 = 452,                   /* $@34  */
  YYSYMBOL_453_35 = 453,                   /* $@35  */
  YYSYMBOL_454_36 = 454,                   /* $@36  */
  YYSYMBOL_cat6_loadib = 455,              /* cat6_loadib  */
  YYSYMBOL_456_37 = 456,                   /* $@37  */
  YYSYMBOL_cat6_storeib = 457,             /* cat6_storeib  */
  YYSYMBOL_458_38 = 458,                   /* $@38  */
  YYSYMBOL_cat6_prefetch = 459,            /* cat6_prefetch  */
  YYSYMBOL_460_39 = 460,                   /* $@39  */
  YYSYMBOL_cat6_atomic_opc = 461,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 462,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 463,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 464,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 465,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 466,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 467,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 468,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 469,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 470,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 471,                 /* cat6_ibo  */
  YYSYMBOL_472_40 = 472,                   /* $@40  */
  YYSYMBOL_cat6_id_opc = 473,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 474,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 475,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 476,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 477,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 478, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 479, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 480, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 481,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 482,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 483, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 484,        /* cat6_bindless_ldc  */
  YYSYMBOL_stc_dst = 485,                  /* stc_dst  */
  YYSYMBOL_cat6_stc = 486,                 /* cat6_stc  */
  YYSYMBOL_487_41 = 487,                   /* $@41  */
  YYSYMBOL_cat6_todo = 488,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 489,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 490,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 491,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 492,             /* cat7_barrier  */
  YYSYMBOL_493_42 = 493,                   /* $@42  */
  YYSYMBOL_494_43 = 494,                   /* $@43  */
  YYSYMBOL_cat7_data_cache = 495,          /* cat7_data_cache  */
  YYSYMBOL_cat7_instr = 496,               /* cat7_instr  */
  YYSYMBOL_raw_instr = 497,                /* raw_instr  */
  YYSYMBOL_src = 498,                      /* src  */
  YYSYMBOL_dst = 499,                      /* dst  */
  YYSYMBOL_const = 500,                    /* const  */
  YYSYMBOL_dst_reg_flag = 501,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 502,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 503,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 504,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 505,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 506,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 507,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 508,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 509,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 510,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 511, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 512,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 513,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 514,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 515,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 516,           /* relative_const  */
  YYSYMBOL_relative = 517,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 518,           /* immediate_cat1  */
  YYSYMBOL_immediate = 519,                /* immediate  */
  YYSYMBOL_flut_immed = 520,               /* flut_immed  */
  YYSYMBOL_integer = 521,                  /* integer  */
  YYSYMBOL_float = 522,                    /* float  */
  YYSYMBOL_type = 523                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 308 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 907 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1401

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  350
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  174
/* YYNRULES -- Number of rules.  */
#define YYNRULES  552
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1146

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   579


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   331,     2,   332,     2,     2,     2,     2,
     327,   328,     2,   338,   326,   325,   333,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   330,     2,
     339,   329,   348,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   341,     2,   342,     2,     2,     2,   334,     2,   345,
       2,     2,     2,   340,   349,     2,     2,   344,   343,     2,
       2,   335,   336,     2,   347,   337,     2,     2,     2,   346,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   698,   698,   698,   700,   701,   703,   704,   705,   706,
     707,   708,   709,   710,   711,   712,   713,   714,   716,   717,
     718,   719,   721,   727,   732,   740,   742,   742,   748,   754,
     761,   768,   777,   779,   781,   784,   786,   788,   795,   796,
     797,   798,   799,   800,   801,   803,   804,   806,   807,   809,
     810,   811,   812,   813,   814,   815,   816,   817,   818,   820,
     822,   823,   825,   826,   828,   829,   831,   832,   832,   833,
     833,   834,   834,   835,   835,   836,   836,   837,   837,   838,
     838,   839,   839,   840,   840,   841,   842,   842,   843,   844,
     845,   846,   847,   848,   849,   849,   850,   851,   852,   853,
     854,   854,   855,   856,   856,   857,   858,   858,   859,   859,
     860,   861,   861,   863,   866,   870,   871,   873,   873,   889,
     889,   896,   896,   903,   903,   905,   905,   907,   907,   910,
     911,   912,   913,   914,   915,   916,   917,   919,   920,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,   931,
     932,   934,   935,   936,   937,   938,   939,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   956,   957,   958,   959,   960,   961,   962,   963,
     964,   965,   966,   967,   969,   970,   971,   972,   973,   974,
     976,   977,   978,   980,   981,   983,   984,   986,   987,   988,
     989,   990,   991,   992,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1003,  1004,  1005,  1006,  1007,  1009,  1010,
    1012,  1013,  1015,  1016,  1017,  1018,  1020,  1021,  1022,  1023,
    1024,  1025,  1026,  1027,  1028,  1029,  1031,  1033,  1034,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  1056,
    1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1081,  1082,  1083,  1084,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1104,  1105,  1107,  1108,  1109,  1110,  1112,
    1113,  1114,  1115,  1116,  1117,  1119,  1122,  1127,  1133,  1133,
    1134,  1134,  1135,  1135,  1136,  1136,  1137,  1137,  1138,  1138,
    1138,  1142,  1142,  1143,  1143,  1144,  1144,  1145,  1145,  1146,
    1146,  1148,  1148,  1149,  1149,  1151,  1151,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1165,  1166,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1177,
    1178,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,  1187,
    1189,  1191,  1193,  1195,  1196,  1197,  1199,  1201,  1202,  1204,
    1205,  1206,  1206,  1209,  1210,  1211,  1213,  1215,  1216,  1218,
    1219,  1220,  1222,  1223,  1225,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1240,  1242,  1243,
    1244,  1246,  1250,  1251,  1253,  1259,  1260,  1261,  1263,  1263,
    1265,  1266,  1267,  1269,  1270,  1271,  1272,  1273,  1274,  1275,
    1276,  1277,  1278,  1279,  1280,  1282,  1283,  1284,  1285,  1287,
    1288,  1290,  1290,  1291,  1291,  1293,  1294,  1295,  1297,  1298,
    1299,  1300,  1302,  1304,  1305,  1306,  1307,  1309,  1310,  1311,
    1312,  1314,  1316,  1317,  1318,  1319,  1320,  1322,  1323,  1326,
    1327,  1329,  1330,  1331,  1332,  1334,  1335,  1337,  1338,  1340,
    1341,  1343,  1344,  1346,  1347,  1349,  1350,  1351,  1353,  1354,
    1355,  1357,  1358,  1359,  1361,  1362,  1363,  1365,  1366,  1368,
    1369,  1371,  1372,  1374,  1375,  1381,  1382,  1383,  1384,  1385,
    1386,  1387,  1389,  1390,  1391,  1392,  1393,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1409,
    1410,  1411,  1412,  1414,  1415,  1417,  1418,  1419,  1420,  1421,
    1422,  1423,  1424
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_HR", "T_HC",
  "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI", "T_WRMASK",
  "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0", "T_FLUT_E",
  "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E", "T_FLUT_LOG2_E",
  "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0", "T_SY", "T_SS",
  "T_JP", "T_SAT", "T_RPT", "T_UL", "T_NOP", "T_OP_NOP", "T_OP_BR",
  "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC", "T_OP_BANY", "T_OP_BALL",
  "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL", "T_OP_RET", "T_OP_KILL",
  "T_OP_END", "T_OP_EMIT", "T_OP_CUT", "T_OP_CHMASK", "T_OP_CHSH",
  "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS", "T_OP_STKR", "T_OP_XSET",
  "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE", "T_OP_DBG", "T_OP_SHPS",
  "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF", "T_OP_PREDE", "T_OP_MOVMSK",
  "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV", "T_OP_COV", "T_OP_SWZ",
  "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F", "T_OP_MIN_F", "T_OP_MAX_F",
  "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F", "T_OP_ABSNEG_F",
  "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F", "T_OP_RNDNE_F",
  "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U", "T_OP_ADD_S", "T_OP_SUB_U",
  "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S", "T_OP_MIN_U", "T_OP_MIN_S",
  "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S", "T_OP_AND_B", "T_OP_OR_B",
  "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U", "T_OP_CMPV_S", "T_OP_MUL_U24",
  "T_OP_MUL_S24", "T_OP_MULL_U", "T_OP_BFREV_B", "T_OP_CLZ_S",
  "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B", "T_OP_ASHR_B", "T_OP_BARY_F",
  "T_OP_FLAT_B", "T_OP_MGEN_B", "T_OP_GETBIT_B", "T_OP_SETRM",
  "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD", "T_OP_MAD_U16",
  "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16", "T_OP_MAD_U24",
  "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32", "T_OP_SEL_B16",
  "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32", "T_OP_SEL_F16",
  "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32", "T_OP_SHRM", "T_OP_SHLM",
  "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG", "T_OP_DP2ACC", "T_OP_DP4ACC",
  "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP", "T_OP_RSQ", "T_OP_LOG2",
  "T_OP_EXP2", "T_OP_SIN", "T_OP_COS", "T_OP_SQRT", "T_OP_HRSQ",
  "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM", "T_OP_ISAML", "T_OP_ISAMM",
  "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML", "T_OP_SAMGQ", "T_OP_GETLOD",
  "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE", "T_OP_GETBUF", "T_OP_GETPOS",
  "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY", "T_OP_GATHER4R", "T_OP_GATHER4G",
  "T_OP_GATHER4B", "T_OP_GATHER4A", "T_OP_SAMGP0", "T_OP_SAMGP1",
  "T_OP_SAMGP2", "T_OP_SAMGP3", "T_OP_DSXPP_1", "T_OP_DSYPP_1",
  "T_OP_RGETPOS", "T_OP_RGETINFO", "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST",
  "T_OP_QSHUFFLE_H", "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV",
  "T_OP_LDG", "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG",
  "T_OP_STG_A", "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L",
  "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT",
  "T_OP_RESINFO", "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_BAR", "T_OP_FENCE", "T_OP_SLEEP", "T_OP_ICINV",
  "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU", "T_RAW", "T_TYPE_F16",
  "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16", "T_TYPE_S32",
  "T_TYPE_U8", "T_TYPE_S8", "T_UNTYPED", "T_TYPED", "T_MIXED",
  "T_UNSIGNED", "T_LOW", "T_HIGH", "T_1D", "T_2D", "T_3D", "T_4D", "T_LT",
  "T_LE", "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN", "T_SAMP", "T_TEX",
  "T_BASE", "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM", "T_IMM", "T_NAN",
  "T_INF", "T_A0", "T_A1", "T_P0", "T_W", "T_CAT1_TYPE_TYPE", "'-'", "','",
  "'('", "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'", "'o'", "'p'",
  "'s'", "'+'", "'<'", "'g'", "'['", "']'", "'l'", "'k'", "'c'", "'w'",
  "'r'", "'>'", "'h'", "$accept", "shader", "$@1", "headers", "header",
  "const_val", "localsize_header", "const_header", "buf_header_addr_reg",
  "buf_header", "$@2", "invocationid_header", "wgid_header",
  "numwg_header", "branchstack_header", "pvtmem_header",
  "earlypreamble_header", "in_header", "out_header", "tex_header", "iflag",
  "iflags", "instrs", "instr", "label", "cat0_src1", "cat0_src2",
  "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17",
  "$@18", "cat1_opc", "cat1_src", "cat1_movmsk", "$@19", "cat1_mova1",
  "$@20", "cat1_mova", "$@21", "cat1_swz", "$@22", "cat1_gat", "$@23",
  "cat1_sct", "$@24", "cat1_instr", "cat2_opc_1src", "cat2_opc_2src_cnd",
  "cat2_opc_2src", "cond", "cat2_instr", "cat3_dp_signedness",
  "cat3_dp_pack", "cat3_opc", "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp",
  "cat3_instr", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp", "cat5_opc",
  "cat5_flag", "cat5_flags", "cat5_samp", "cat5_tex", "cat5_type",
  "cat5_a1", "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type",
  "cat6_imm_offset", "cat6_offset", "cat6_dst_offset", "cat6_immed",
  "cat6_stg_ldg_a6xx_offset", "cat6_load", "$@25", "$@26", "$@27", "$@28",
  "$@29", "$@30", "$@31", "cat6_store", "$@32", "$@33", "$@34", "$@35",
  "$@36", "cat6_loadib", "$@37", "cat6_storeib", "$@38", "cat6_prefetch",
  "$@39", "cat6_atomic_opc", "cat6_a3xx_atomic_opc",
  "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s", "cat6_a6xx_atomic_g",
  "cat6_atomic_l", "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_2src_dst", "cat6_bindless_ibo",
  "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle", "cat6_bindless_ldc",
  "stc_dst", "cat6_stc", "$@41", "cat6_todo", "cat6_instr", "cat7_scope",
  "cat7_scopes", "cat7_barrier", "$@42", "$@43", "cat7_data_cache",
  "cat7_instr", "raw_instr", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "offset", "relative_gpr_src",
  "relative_gpr_dst", "relative_const", "relative", "immediate_cat1",
  "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-854)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -854,    14,   944,  -854,    59,  -299,    59,  -278,  -272,  -270,
      59,  -258,  -256,  -248,    59,  -854,   488,   944,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,    78,  -241,   128,  -854,   136,    97,   138,
    -854,   146,   196,   205,  -854,  -108,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,   864,  1117,   619,  -854,  -854,  -854,
    -854,  -854,    59,  -102,   -98,   -82,   -79,   -78,   -77,   -57,
     -47,   -42,  -854,  -854,  -854,  -854,  -854,  -854,   -44,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,   -43,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,   -34,   -20,   -17,   -25,   -23,
     -22,   -21,   -18,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,    45,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,   180,   -10,   180,
    -854,   180,   180,   180,    -8,  -854,   180,  -854,    25,    25,
    -854,  -854,  -854,  -854,  -854,  -854,    27,    27,    27,  -854,
    -854,  -854,  -854,    37,    27,    27,  -854,    37,  -854,    27,
      27,    27,  -854,    40,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,     1,    59,   308,  -854,  -854,  -854,  -854,  -854,
     335,   363,   372,  -236,  -236,  -236,    36,  -236,  -236,    48,
      48,    48,  -236,    48,    62,    48,    48,  -236,  -236,    64,
      63,    67,    66,    70,    84,    95,    96,    37,    37,    37,
      37,    37,    37,    37,    37,    27,    69,    37,    37,    27,
      37,    37,    55,    55,  -854,    82,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,    99,  -854,   267,     9,   119,   120,
     125,  -112,   126,   129,   139,   145,  -146,   131,   155,   615,
      25,   180,   150,  -137,   149,   149,   149,   417,   149,   149,
     149,   180,   149,   149,   149,     8,    59,   157,   144,   158,
     164,   163,  -854,   162,   167,   169,   171,  -854,  -854,   182,
    -854,   177,   184,    47,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,   180,   180,   180,   180,   178,   179,   174,   187,
     149,   198,   180,   197,   149,   180,   201,   113,    55,  -854,
    -854,   222,   227,  -854,  -854,   620,   620,   141,  -854,  -854,
    -854,  -854,  -854,  -854,   180,   141,   579,   818,   419,  -854,
    -854,   -63,   180,   141,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,   199,   417,   180,  -854,  -854,
     -36,    37,    37,    37,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,   180,    37,    37,  -854,    37,    37,    37,
     215,   217,   228,  -854,  -854,    59,  -854,   549,   550,    36,
    -854,    48,  -220,  -220,  -854,  -854,    48,    48,    48,  -854,
    -854,    48,   180,   620,   620,   180,   180,   180,   232,   237,
     239,   241,   229,   233,   234,   238,    37,    54,   246,   253,
      37,   254,   257,  -854,  -854,  -854,  -854,  -854,  -295,  -295,
    -854,  -854,  -854,  -854,  -854,  -854,   258,   268,  -854,  -854,
    -854,   151,   269,   270,   285,  -854,  -854,  -854,   316,    34,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,    36,   721,   310,  -854,  -854,  -854,  -854,  -854,
     287,   288,   290,    54,  -854,   291,  -854,  -854,  -854,   292,
    -854,  -854,  -854,   295,  -854,    85,   298,   303,  -854,  -854,
    -854,  -854,   300,   301,   306,   314,   318,   320,   337,   339,
     346,    36,   329,    -1,   355,   307,   353,   357,  -854,  -854,
     364,   361,   362,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
     367,   369,   370,   358,   360,   354,   365,    54,    54,    54,
      54,   378,  -280,   373,    54,   379,   374,    93,    36,    36,
     375,   377,   393,   398,  -854,   394,   401,   116,   405,   406,
     415,   416,    79,  -854,  -854,  -854,  -854,   410,    36,  -854,
    -854,   141,   141,   231,   231,    85,   818,  -854,  -854,   193,
      36,    36,    36,   381,    36,    36,    36,    36,    36,   409,
     411,   400,  -854,  -854,    59,    36,    36,   740,  -854,    48,
      48,   180,    85,   180,   407,   424,   426,   428,  -295,   412,
    -186,  -186,    36,    -1,  -854,   429,  -854,   431,  -186,    36,
     433,   413,   434,  -854,  -854,  -854,  -854,  -854,  -295,  -295,
    -854,  -854,  -854,  -854,  -854,  -295,  -295,   442,   447,  -854,
     449,   421,  -854,   127,   453,   455,   456,   457,  -854,  -854,
     461,  -854,   466,   458,   460,   463,   459,   180,  -854,   464,
     469,   470,  -147,  -147,    -1,   468,   471,   476,   477,  -854,
    -854,   472,   479,   481,    54,    54,    54,    54,   473,   153,
     474,    -1,   475,  -854,   484,   180,  -854,   485,    54,   487,
     490,    36,    36,   501,   462,   497,   498,   499,  -854,  -854,
    -854,   141,   579,   818,    90,   231,   502,   193,   493,   508,
     509,    -1,   512,   530,  -147,  -147,  -147,   538,   538,   538,
     180,   529,  -854,    59,  -854,  -854,    36,    85,    85,   180,
    -280,   412,  -280,  -280,   553,    54,   544,   563,  -854,   564,
     565,   568,    36,  -280,   569,   555,   556,  -854,    85,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,   571,  -854,   576,
    -854,   577,   180,   180,   180,   573,   566,   578,   180,    85,
     180,   592,  -854,  -854,  -854,  -854,   580,  -854,   594,   596,
     597,   601,   587,   591,   593,   595,    54,  -295,   600,    54,
      54,    54,   603,  -854,   602,    54,    90,  -854,   608,   818,
     256,   193,   622,   640,   642,  -854,   605,    -1,   644,   645,
     646,  -854,   652,   912,    85,    85,   180,   648,   649,   650,
     651,   653,   654,    36,   655,   657,   658,   637,   659,   660,
     638,   661,    36,  -854,  -854,  -854,  -854,   662,  -854,  -854,
     647,   656,    54,    -1,   663,    -1,    -1,    -1,   664,   665,
    -854,   666,   667,    90,    90,    90,    90,    90,   668,  -295,
      90,    90,    90,    90,    90,    90,   669,    90,  -854,   256,
     670,   671,   672,   673,   674,  -854,   675,   676,  -854,    36,
      85,    85,  -854,  -854,  -854,  -854,  -854,   680,   681,  -854,
    -854,  -854,   679,  -854,  -854,    54,  -854,  -854,  -854,    -1,
      -1,    54,   677,    54,    -1,    -1,   678,  -854,  -854,    36,
     683,   682,   684,   685,   686,  -854,    54,   687,  -854,  -854,
     983,  -854,    36,    54,    54,   688,   697,   698,    -1,   696,
    -854,   700,   705,    54,    54,    54,   709,    36,    54,    54,
    -854,   710,  -854,    54,   711,  -854,  -854,    54,  -854,   985,
     712,   713,    54,    36,  -854,  -854
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    45,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    26,     0,     0,     0,
      32,     0,     0,     0,    33,     0,    38,    39,    40,    41,
      42,    43,    44,   462,    45,     0,    45,    48,    58,    57,
       5,    20,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,    59,    46,    66,    67,    69,    71,     0,    75,
      77,    79,    81,    83,    85,    86,    88,    89,    90,    91,
      92,    93,    94,    96,    97,    98,    99,     0,   100,   102,
     103,   105,   106,   108,   110,     0,     0,     0,     0,     0,
       0,     0,     0,   157,   158,   159,   160,   141,   151,   137,
     154,   142,   143,   144,   145,   146,   161,   162,   163,   164,
     152,   153,   165,   166,   167,   168,   138,   169,   170,   147,
     171,   155,   156,   172,   173,   174,   148,   140,   139,   175,
     176,   177,   178,   179,   180,   181,   149,   150,   182,   183,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   220,   221,   218,   219,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   237,
     238,   263,   264,   265,   266,   267,   268,   269,   302,   318,
     320,   324,   322,   331,   333,   337,   335,   341,   430,   431,
     345,   326,   339,   432,   386,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   404,   417,   416,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   387,   388,   343,   421,   328,   393,   394,   395,
     428,   451,   453,   460,   461,   455,   456,   457,    49,     0,
     129,   130,   131,   132,   133,   134,    50,     0,     0,     0,
      51,     0,     0,     0,     0,    52,     0,    53,   280,   280,
      54,   433,   435,   434,   436,   437,     0,     0,     0,   384,
     385,   383,   438,     0,     0,     0,   439,     0,   440,     0,
       0,     0,   442,     0,   441,   443,   444,    55,   458,   459,
      56,    47,     0,     0,     0,    27,    28,    29,    30,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   449,   449,   467,     0,   472,   473,   474,   475,
     476,   468,   469,   470,     0,   479,   477,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     280,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    61,     0,     0,     0,     0,   539,   541,     0,
      73,     0,     0,     0,    80,    82,    84,    87,    95,   111,
     101,   104,   107,   109,   117,   119,   121,   113,   114,   123,
     125,   127,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   449,   452,
     454,     0,     0,   478,   480,     0,     0,     0,   184,   185,
     186,   187,   188,   189,     0,     0,     0,     0,     0,   193,
     194,     0,     0,     0,   270,   275,   278,   276,   277,   279,
     271,   272,   273,   274,   281,     0,     0,     0,   303,   304,
       0,     0,     0,     0,   545,   546,   547,   548,   549,   550,
     551,   552,   309,     0,     0,     0,   396,     0,     0,     0,
       0,     0,     0,   315,    22,     0,    24,     0,     0,     0,
      60,     0,     0,     0,   540,   542,     0,     0,     0,    65,
      64,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   448,   447,   445,   446,   450,   504,   504,
     463,   471,   481,   482,   483,   484,     0,     0,   464,   465,
     466,     0,     0,     0,     0,   135,   487,   491,   485,     0,
     493,   494,   495,   115,   513,   514,   496,   116,   515,   136,
     527,   528,   529,   530,   531,   532,   533,   534,   535,   536,
     537,   538,     0,     0,     0,   498,   190,   500,   524,   522,
       0,     0,     0,     0,   501,     0,   502,   503,   489,     0,
     490,   195,   196,     0,   236,     0,     0,   301,   305,   306,
     307,   308,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    68,    63,
       0,     0,     0,    74,    76,    78,   112,   118,   120,   122,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   504,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   543,     0,     0,     0,     0,     0,
       0,     0,     0,   486,   488,   492,   497,     0,     0,   526,
     499,     0,     0,     0,     0,     0,     0,   286,   284,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   402,   403,     0,     0,     0,     0,    62,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   504,     0,
     504,   504,     0,     0,   311,     0,   310,     0,   504,     0,
       0,   426,     0,   425,   506,   505,   510,   509,   504,   504,
     520,   521,   544,   516,   517,   504,   504,     0,     0,   523,
       0,     0,   192,     0,     0,     0,     0,     0,   282,   283,
     299,   300,   297,     0,     0,     0,     0,     0,   391,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    70,
      72,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   313,     0,     0,   312,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   518,   519,
     525,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   397,   397,   397,
       0,     0,   424,     0,    35,    36,     0,     0,     0,     0,
     504,     0,   504,   504,     0,     0,     0,     0,   314,     0,
       0,     0,     0,   504,     0,     0,     0,   427,     0,   508,
     512,   511,   507,   191,   222,   223,   224,     0,   298,   295,
     296,   292,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   400,   401,   399,   422,     0,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   504,     0,     0,
       0,     0,     0,   346,     0,     0,     0,   329,     0,     0,
       0,     0,     0,     0,     0,   389,     0,     0,     0,     0,
       0,   398,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   225,   293,   294,   285,   290,   291,   287,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     124,     0,     0,     0,     0,     0,     0,     0,     0,   504,
       0,     0,     0,     0,     0,     0,     0,     0,   429,     0,
       0,     0,     0,     0,     0,   418,     0,     0,   423,     0,
       0,     0,   319,   321,   325,   323,   332,     0,     0,   334,
     338,   336,     0,   327,   340,     0,   330,   288,   289,     0,
       0,     0,     0,     0,     0,     0,     0,   126,   128,     0,
       0,     0,     0,     0,     0,   381,     0,     0,   419,   420,
       0,   316,     0,     0,     0,     0,     0,     0,     0,     0,
     317,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     382,     0,   390,     0,     0,   342,   344,     0,   392,     0,
       0,     0,     0,     0,   380,    37
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -854,  -854,  -854,   980,  -854,    -6,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,   945,  -854,   953,  -854,   134,   467,  -354,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -481,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -322,  -853,  -819,
    -854,   -19,  -854,   340,   432,   465,   243,  -675,  -698,  -502,
     118,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -667,  -805,  -202,  -854,  -854,
    -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,  -854,
    -854,  -392,  -854,  -854,  -854,  -854,  -854,  -854,  -305,   616,
    -573,  -854,   618,  -304,  -854,  -479,  -460,  -854,  -854,  -674,
    -506,  -500,  -732,  -595,   517,  -854,  -854,  -522,  -854,  -462,
     383,  -375,   297,   505
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,    34,    18,    19,   365,    20,
      64,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      54,    55,    56,    57,    58,   464,   711,   474,   308,   373,
     374,   375,   586,   377,   378,   379,   380,   381,   382,   383,
     385,   386,   387,   388,   591,   309,   635,   310,   592,   311,
     593,   312,   594,   313,   595,   314,   596,   315,   597,   316,
     317,   318,   319,   524,   320,   437,   532,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   440,   441,   840,   841,
     547,  1025,   330,   444,   551,   448,   804,   805,   872,   571,
     870,   331,   397,   398,   400,   399,   407,   410,  1021,   332,
     401,   402,   404,   403,   408,   333,   405,   334,   409,   335,
     406,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   903,   347,   348,   962,   910,   781,   349,   350,
     351,   352,   353,   572,   354,   812,   355,   411,   356,   357,
     508,   509,   358,   412,   413,   359,   360,    59,   636,   425,
     637,   426,   427,   428,   638,   673,   640,   679,   641,   642,
     665,   666,   675,   806,   644,   429,   645,   646,   647,   667,
     668,   669,   749,   562
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   470,   467,   468,    40,   676,   620,   442,    44,   643,
     643,   467,   468,   430,     3,   432,   414,   433,   434,   435,
     672,   510,   438,   740,   741,   671,   475,   476,    35,   478,
     738,   480,   481,   684,   837,   649,   639,   639,   664,   467,
     468,   620,   621,   739,   949,   738,   664,   639,   911,    37,
     467,   468,   414,   589,   664,    38,   362,    39,   803,   626,
     627,   620,    30,    31,    32,   677,   755,   674,   678,    41,
     415,    42,   416,   417,   418,   419,   420,   948,   950,    43,
     573,    61,   467,   468,   744,    62,   462,   643,   643,   834,
     835,   755,   620,   467,   468,   463,   467,   468,   590,   958,
     959,   960,   709,   874,    66,    67,   622,   623,   624,   625,
     879,   710,   718,   719,   639,   639,   617,   756,   544,   584,
     585,   822,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   620,   621,    63,   545,  1027,   738,
     648,   648,   756,    65,   467,   468,    68,   566,   620,   621,
     529,   530,   871,    69,   467,   468,   744,   548,   549,   753,
     620,   945,   622,   623,   624,   625,   626,   627,   907,   908,
     909,  1024,  1028,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   584,   585,   414,   598,   599,
     600,   601,   518,   519,   520,   521,   522,   523,   608,   779,
     620,   611,   760,    70,   707,   873,   873,   416,   417,   418,
     419,   420,    71,   873,   622,   623,   624,   625,   648,   648,
     670,   947,    72,   884,   885,   767,   363,   708,   683,   364,
     886,   887,   713,   714,   715,   681,   682,   716,   620,   621,
    1087,   963,   964,   687,   676,   972,   366,   974,   975,   367,
     368,   369,   622,   623,   624,   625,   748,  1023,   984,   695,
     755,   831,   832,   620,   688,   689,   690,   691,   843,   844,
     845,   370,   847,   848,   849,   850,   851,   622,   623,   624,
     625,   371,   664,   664,   833,   833,   372,   757,   717,   376,
     384,   720,   721,   722,   416,   417,   418,   419,   420,   389,
     875,   390,   732,   391,   677,   836,   674,   880,   392,   842,
     393,   394,   395,   467,   468,   396,   458,   620,   621,   628,
     629,   630,   570,   431,   469,   436,   573,   456,   783,   421,
     422,   423,   862,   469,   754,   626,   627,   622,   623,   624,
     625,   459,   650,   651,   652,   653,   654,   655,   656,   657,
     658,   659,   660,   661,   628,   629,   630,   457,   439,   754,
     443,   469,   813,   814,   815,   421,   422,   423,   754,   460,
     447,   676,   469,   455,   628,   629,   630,   827,   461,   632,
     473,   633,  1012,   830,    33,   479,   944,   484,   507,   485,
     487,   943,   424,   486,   488,   573,   573,   573,   782,   573,
     573,   573,   573,   573,   747,   628,   629,   630,   489,   501,
     856,   857,   664,   639,   811,   469,   833,   662,   469,   490,
     491,   511,   798,   799,   800,   801,   620,   573,   815,   808,
     983,   677,   946,   674,   573,   859,   860,   951,   512,   663,
     622,   623,   624,   625,   626,   515,   516,   628,   629,   630,
     574,   517,   525,   613,  1078,   526,   614,   969,   970,   615,
     616,   628,   629,   630,   531,   527,   469,   676,   662,   745,
     746,   528,   576,   628,   629,   630,   747,   546,   988,   783,
     925,   533,   550,   575,   580,   577,   632,   861,   633,   863,
     663,   578,   579,   581,    45,   582,   815,   583,   876,   999,
     421,   422,   423,   587,   838,   839,   936,   937,   465,   466,
     588,   471,   472,   628,   629,   630,   477,   604,   602,   603,
    1058,   482,   483,   605,  1020,   685,   783,   677,   754,   674,
    1026,  1029,    46,    47,    48,    49,    50,    51,    52,   607,
     609,   968,   618,   902,  1040,  1041,   612,   619,   701,   782,
     702,   628,   629,   630,   703,   705,   706,   573,   723,   920,
     921,   922,   923,   724,   926,   725,   928,   726,   839,   704,
     727,   931,   733,   933,   728,   729,   628,   629,   630,   730,
     736,  1072,  1073,  1074,  1075,  1076,   620,   621,  1079,  1080,
    1081,  1082,  1083,  1084,   734,  1086,   782,   742,   737,  1026,
     622,   623,   624,   625,   626,   627,   965,   743,   750,   751,
    1097,  1098,   752,   761,   762,   971,   763,   764,   765,    -3,
     977,   766,   783,   467,   468,    45,   768,   620,   621,   769,
     628,   629,   630,   770,   771,   469,   785,   662,  1049,   772,
     773,   622,   623,   624,   625,   626,   627,   573,   992,   993,
     994,   774,   912,   775,   998,   632,  1000,   633,   783,   663,
     783,   783,   783,    46,    47,    48,    49,    50,    51,    52,
     776,  1011,   777,   780,  1014,  1015,  1016,   445,   446,   778,
    1019,   784,   786,   787,   449,   450,   788,   789,   790,   452,
     453,   454,   782,   791,  1096,   792,   793,   796,   794,   955,
     795,   797,  1042,   554,   555,   556,   557,   558,   559,   560,
     561,   802,   809,   818,   783,   783,   807,   810,   819,   783,
     783,   846,   820,   816,  1111,   817,   854,  1062,   782,   821,
     782,   782,   782,   823,   824,   825,   826,  1120,   829,   628,
     629,   630,   852,   783,   853,   500,   858,   891,   864,   504,
     869,   882,  1134,   650,   651,   652,   653,   654,   655,   656,
     657,   658,   659,   660,   661,   865,   633,   866,  1145,   867,
     888,   877,   878,    53,   881,   889,   883,   890,   855,   892,
    1102,   893,   894,   895,   782,   782,  1105,   896,  1107,   782,
     782,   898,   897,   899,   913,  1034,   900,   904,   917,   914,
     901,  1117,   905,   906,   915,   918,   916,   919,  1121,  1122,
     939,   932,   451,   782,   839,   924,   927,   929,  1130,  1131,
    1132,   467,   468,  1135,  1136,   620,   930,   938,  1138,   934,
     935,  1063,  1140,  1065,  1066,  1067,   952,  1144,   956,   622,
     623,   624,   625,   626,   627,   940,   941,   942,   953,   954,
     650,   651,   652,   653,   654,   655,   656,   657,   658,   659,
     660,   661,   492,   493,   494,   495,   496,   497,   498,   499,
     957,   961,   502,   503,   966,   505,   506,   552,   553,   976,
     563,   564,   565,   978,   567,   568,   569,  1103,  1104,   979,
     980,   981,  1108,  1109,   982,   985,   986,   989,   987,   628,
     629,   630,   990,   991,    53,  1001,   996,   967,    46,    47,
      48,    49,    50,    51,    52,   995,  1126,   534,  1039,   997,
    1003,  1002,  1004,  1005,   632,   535,   633,  1006,   536,  1007,
     537,   538,   606,  1008,  1022,  1009,   610,  1010,   539,  1013,
     628,   629,   630,  1017,  1018,   469,  1033,   631,  1030,   540,
     541,   542,   543,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,   632,  1031,   633,  1032,   634,
    1035,  1036,  1037,  1038,  1043,  1044,  1045,  1046,  1053,  1047,
    1056,  1050,  1048,  1051,  1052,  1054,  1055,  1057,  1059,  1119,
    1060,  1141,  1070,  1071,  1069,  1085,  1061,    60,  1091,    73,
    1093,  1094,  1095,  1106,  1110,  1064,  1068,  1077,  1113,   361,
    1114,  1089,  1090,  1118,  1123,  1092,   692,   693,   694,  1099,
    1100,  1101,  1112,  1124,  1125,  1127,  1128,  1115,  1116,   696,
     697,  1129,   698,   699,   700,  1133,  1137,  1139,  1142,   973,
    1088,   868,  1143,   514,   513,   680,   759,     0,   758,   828,
     712,   686,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   731,     0,     0,     0,   735,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   628,   629,
     630,     0,     0,   469,     0,   662,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   632,     0,   633,     0,   663,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307
};

static const yytype_int16 yycheck[] =
{
       6,   376,     3,     4,    10,   527,     7,   329,    14,   515,
     516,     3,     4,   317,     0,   319,     7,   321,   322,   323,
     526,   413,   326,   618,   619,   525,   380,   381,   327,   383,
     325,   385,   386,   533,   766,   516,   515,   516,   517,     3,
       4,     7,     8,   338,   897,   325,   525,   526,   853,   327,
       3,     4,     7,     6,   533,   327,    62,   327,   338,    25,
      26,     7,     3,     4,     5,   527,   639,   527,   528,   327,
      25,   327,    27,    28,    29,    30,    31,   896,   897,   327,
     455,     3,     3,     4,     5,   326,   322,   593,   594,   763,
     764,   664,     7,     3,     4,   331,     3,     4,   473,   904,
     905,   906,   322,   801,     7,     8,    21,    22,    23,    24,
     808,   331,   593,   594,   593,   594,   508,   639,   440,     3,
       4,     5,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,     7,     8,     8,   441,   991,   325,
     515,   516,   664,     7,     3,     4,     8,   451,     7,     8,
     296,   297,   338,     7,     3,     4,     5,   294,   295,   638,
       7,   893,    21,    22,    23,    24,    25,    26,   315,   316,
     317,   990,   991,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,     3,     4,     7,   492,   493,
     494,   495,   304,   305,   306,   307,   308,   309,   502,   701,
       7,   505,   664,     7,   579,   800,   801,    27,    28,    29,
      30,    31,     7,   808,    21,    22,    23,    24,   593,   594,
     524,   895,   330,   818,   819,   685,   328,   581,   532,   327,
     825,   826,   586,   587,   588,   298,   299,   591,     7,     8,
    1059,   908,   909,   547,   766,   920,   328,   922,   923,   328,
     328,   328,    21,    22,    23,    24,   631,   989,   933,   563,
     833,   761,   762,     7,   300,   301,   302,   303,   770,   771,
     772,   328,   774,   775,   776,   777,   778,    21,    22,    23,
      24,   328,   761,   762,   763,   764,   328,   662,   592,   333,
     333,   595,   596,   597,    27,    28,    29,    30,    31,   333,
     802,   321,   607,   320,   766,   765,   766,   809,   333,   769,
     333,   333,   333,     3,     4,   333,     8,     7,     8,   320,
     321,   322,   314,   333,   325,   333,   701,   326,   703,   320,
     321,   322,   792,   325,   639,    25,    26,    21,    22,    23,
      24,     6,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,   320,   321,   322,   363,   333,   664,
     333,   325,   737,   738,   739,   320,   321,   322,   673,     6,
     333,   893,   325,   333,   320,   321,   322,   752,     6,   345,
     332,   347,   977,   758,   325,   323,   892,   323,   333,   326,
     324,   891,   347,   326,   324,   770,   771,   772,   703,   774,
     775,   776,   777,   778,   325,   320,   321,   322,   324,   340,
     785,   786,   891,   892,   321,   325,   895,   327,   325,   324,
     324,   339,   727,   728,   729,   730,     7,   802,   803,   734,
     932,   893,   894,   893,   809,   789,   790,   897,   339,   349,
      21,    22,    23,    24,    25,   326,   326,   320,   321,   322,
     456,   326,   326,   340,  1049,   326,   343,   917,   918,   346,
     347,   320,   321,   322,   333,   326,   325,   989,   327,   318,
     319,   326,   328,   320,   321,   322,   325,   327,   938,   854,
     327,   326,   333,   326,   322,   327,   345,   791,   347,   793,
     349,   327,   329,   326,     6,   326,   871,   326,   803,   959,
     320,   321,   322,   326,   311,   312,   881,   882,   374,   375,
     326,   377,   378,   320,   321,   322,   382,   343,   340,   340,
    1022,   387,   388,   336,   986,   326,   901,   989,   833,   989,
     990,   991,    44,    45,    46,    47,    48,    49,    50,   341,
     343,   916,   320,   847,  1004,  1005,   345,   320,   333,   854,
     333,   320,   321,   322,   326,     6,     6,   932,   326,   864,
     865,   866,   867,   326,   869,   326,   871,   326,   312,   575,
     341,   875,   326,   878,   341,   341,   320,   321,   322,   341,
     326,  1043,  1044,  1045,  1046,  1047,     7,     8,  1050,  1051,
    1052,  1053,  1054,  1055,   341,  1057,   901,   339,   341,  1059,
      21,    22,    23,    24,    25,    26,   910,   339,   339,   339,
    1070,  1071,   327,   326,   326,   919,   326,   326,   326,     0,
     925,   326,   997,     3,     4,     6,   328,     7,     8,   326,
     320,   321,   322,   333,   333,   325,   329,   327,  1013,   333,
     326,    21,    22,    23,    24,    25,    26,  1022,   952,   953,
     954,   333,   854,   333,   958,   345,   960,   347,  1033,   349,
    1035,  1036,  1037,    44,    45,    46,    47,    48,    49,    50,
     333,   976,   333,   344,   979,   980,   981,   337,   338,   333,
     985,   326,   329,   326,   344,   345,   322,   326,   326,   349,
     350,   351,   997,   326,  1069,   326,   326,   343,   340,   901,
     340,   336,  1006,   286,   287,   288,   289,   290,   291,   292,
     293,   333,   333,   320,  1089,  1090,   343,   343,   320,  1094,
    1095,   340,   328,   348,  1099,   348,   326,  1032,  1033,   328,
    1035,  1036,  1037,   328,   328,   320,   320,  1112,   328,   320,
     321,   322,   333,  1118,   333,   405,     6,   326,   341,   409,
     338,   338,  1127,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,   341,   347,   341,  1143,   341,
     328,   342,   341,   285,   341,   328,   342,   328,   784,   326,
    1085,   326,   326,   326,  1089,  1090,  1091,   326,  1093,  1094,
    1095,   333,   326,   333,   326,   997,   333,   333,   326,   328,
     341,  1106,   333,   333,   328,   326,   329,   326,  1113,  1114,
     348,   326,   347,  1118,   312,   342,   342,   342,  1123,  1124,
    1125,     3,     4,  1128,  1129,     7,   342,   326,  1133,   342,
     340,  1033,  1137,  1035,  1036,  1037,   343,  1142,   326,    21,
      22,    23,    24,    25,    26,   348,   348,   348,   340,   340,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,   397,   398,   399,   400,   401,   402,   403,   404,
     340,   333,   407,   408,   345,   410,   411,   445,   446,   326,
     448,   449,   450,   339,   452,   453,   454,  1089,  1090,   326,
     326,   326,  1094,  1095,   326,   326,   341,   326,   342,   320,
     321,   322,   326,   326,   285,   313,   340,   913,    44,    45,
      46,    47,    48,    49,    50,   342,  1118,   302,     6,   341,
     326,   341,   326,   326,   345,   310,   347,   326,   313,   342,
     315,   316,   500,   342,   326,   342,   504,   342,   323,   339,
     320,   321,   322,   340,   342,   325,   341,   327,   326,   334,
     335,   336,   337,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,   345,   326,   347,   326,   349,
     326,   326,   326,   321,   326,   326,   326,   326,   341,   326,
     342,   326,   328,   326,   326,   326,   326,   326,   326,     6,
     343,     6,   326,   326,   329,   326,   340,    17,   326,    54,
     326,   326,   326,   326,   326,   342,   342,   339,   326,    56,
     326,   341,   341,   326,   326,   342,   551,   552,   553,   339,
     339,   342,   339,   326,   326,   329,   326,   342,   342,   564,
     565,   326,   567,   568,   569,   326,   326,   326,   326,   921,
    1059,   798,   329,   427,   426,   528,   663,    -1,   327,   752,
     583,   546,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   606,    -1,    -1,    -1,   610,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,
     322,    -1,    -1,   325,    -1,   327,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   345,    -1,   347,    -1,   349,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   351,   352,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   353,   354,   356,   357,
     359,   361,   362,   363,   364,   365,   366,   367,   368,   369,
       3,     4,     5,   325,   355,   327,   355,   327,   327,   327,
     355,   327,   327,   327,   355,     6,    44,    45,    46,    47,
      48,    49,    50,   285,   370,   371,   372,   373,   374,   497,
     353,     3,   326,     8,   360,     7,     7,     8,     8,     7,
       7,     7,   330,   371,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   378,   395,
     397,   399,   401,   403,   405,   407,   409,   410,   411,   412,
     414,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     432,   441,   449,   455,   457,   459,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   473,   474,   478,
     479,   480,   481,   482,   484,   486,   488,   489,   492,   495,
     496,   373,   355,   328,   327,   358,   328,   328,   328,   328,
     328,   328,   328,   379,   380,   381,   333,   383,   384,   385,
     386,   387,   388,   389,   333,   390,   391,   392,   393,   333,
     321,   320,   333,   333,   333,   333,   333,   442,   443,   445,
     444,   450,   451,   453,   452,   456,   460,   446,   454,   458,
     447,   487,   493,   494,     7,    25,    27,    28,    29,    30,
      31,   320,   321,   322,   347,   499,   501,   502,   503,   515,
     503,   333,   503,   503,   503,   503,   333,   415,   503,   333,
     426,   427,   427,   333,   433,   433,   433,   333,   435,   433,
     433,   435,   433,   433,   433,   333,   326,   355,     8,     6,
       6,     6,   322,   331,   375,   375,   375,     3,     4,   325,
     521,   375,   375,   332,   377,   377,   377,   375,   377,   323,
     377,   377,   375,   375,   323,   326,   326,   324,   324,   324,
     324,   324,   435,   435,   435,   435,   435,   435,   435,   435,
     433,   340,   435,   435,   433,   435,   435,   333,   490,   491,
     491,   339,   339,   502,   499,   326,   326,   326,   304,   305,
     306,   307,   308,   309,   413,   326,   326,   326,   326,   296,
     297,   333,   416,   326,   302,   310,   313,   315,   316,   323,
     334,   335,   336,   337,   427,   503,   327,   430,   294,   295,
     333,   434,   434,   434,   286,   287,   288,   289,   290,   291,
     292,   293,   523,   434,   434,   434,   503,   434,   434,   434,
     314,   439,   483,   521,   355,   326,   328,   327,   327,   329,
     322,   326,   326,   326,     3,     4,   382,   326,   326,     6,
     521,   394,   398,   400,   402,   404,   406,   408,   503,   503,
     503,   503,   340,   340,   343,   336,   434,   341,   503,   343,
     434,   503,   345,   340,   343,   346,   347,   491,   320,   320,
       7,     8,    21,    22,    23,    24,    25,    26,   320,   321,
     322,   327,   345,   347,   349,   396,   498,   500,   504,   505,
     506,   508,   509,   510,   514,   516,   517,   518,   521,   396,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,   327,   349,   505,   510,   511,   519,   520,   521,
     503,   511,   510,   505,   506,   512,   517,   519,   506,   507,
     514,   298,   299,   503,   511,   326,   523,   503,   300,   301,
     302,   303,   435,   435,   435,   503,   435,   435,   435,   435,
     435,   333,   333,   326,   355,     6,     6,   521,   377,   322,
     331,   376,   376,   377,   377,   377,   377,   503,   396,   396,
     503,   503,   503,   326,   326,   326,   326,   341,   341,   341,
     341,   435,   498,   326,   341,   435,   326,   341,   325,   338,
     513,   513,   339,   339,     5,   318,   319,   325,   521,   522,
     339,   339,   327,   505,   498,   500,   517,   521,   327,   520,
     519,   326,   326,   326,   326,   326,   326,   506,   328,   326,
     333,   333,   333,   326,   333,   333,   333,   333,   333,   439,
     344,   477,   498,   521,   326,   329,   329,   326,   322,   326,
     326,   326,   326,   326,   340,   340,   343,   336,   498,   498,
     498,   498,   333,   338,   436,   437,   513,   343,   498,   333,
     343,   321,   485,   521,   521,   521,   348,   348,   320,   320,
     328,   328,     5,   328,   328,   320,   320,   521,   522,   328,
     521,   511,   511,   505,   509,   509,   506,   512,   311,   312,
     428,   429,   506,   439,   439,   439,   340,   439,   439,   439,
     439,   439,   333,   333,   326,   355,   521,   521,     6,   377,
     377,   503,   506,   503,   341,   341,   341,   341,   436,   338,
     440,   338,   438,   513,   438,   439,   498,   342,   341,   438,
     439,   341,   338,   342,   513,   513,   513,   513,   328,   328,
     328,   326,   326,   326,   326,   326,   326,   326,   333,   333,
     333,   341,   503,   472,   333,   333,   333,   315,   316,   317,
     476,   476,   477,   326,   328,   328,   329,   326,   326,   326,
     498,   498,   498,   498,   342,   327,   498,   342,   498,   342,
     342,   503,   326,   498,   342,   340,   521,   521,   326,   348,
     348,   348,   348,   511,   510,   512,   519,   509,   429,   428,
     429,   506,   343,   340,   340,   477,   326,   340,   476,   476,
     476,   333,   475,   475,   475,   503,   345,   355,   521,   506,
     506,   503,   437,   440,   437,   437,   326,   498,   339,   326,
     326,   326,   326,   439,   437,   326,   341,   342,   506,   326,
     326,   326,   503,   503,   503,   342,   340,   341,   503,   506,
     503,   313,   341,   326,   326,   326,   326,   342,   342,   342,
     342,   498,   513,   339,   498,   498,   498,   340,   342,   498,
     519,   448,   326,   512,   429,   431,   506,   428,   429,   506,
     326,   326,   326,   341,   477,   326,   326,   326,   321,     6,
     506,   506,   503,   326,   326,   326,   326,   326,   328,   521,
     326,   326,   326,   341,   326,   326,   342,   326,   439,   326,
     343,   340,   498,   477,   342,   477,   477,   477,   342,   329,
     326,   326,   519,   519,   519,   519,   519,   339,   513,   519,
     519,   519,   519,   519,   519,   326,   519,   429,   431,   341,
     341,   326,   342,   326,   326,   326,   521,   506,   506,   339,
     339,   342,   498,   477,   477,   498,   326,   498,   477,   477,
     326,   521,   339,   326,   326,   342,   342,   498,   326,     6,
     521,   498,   498,   326,   326,   326,   477,   329,   326,   326,
     498,   498,   498,   326,   521,   498,   498,   326,   498,   326,
     498,     6,   326,   329,   498,   521
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   350,   352,   351,   353,   353,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   355,   355,
     355,   355,   356,   357,   358,   358,   360,   359,   361,   362,
     362,   363,   364,   365,   366,   367,   368,   369,   370,   370,
     370,   370,   370,   370,   370,   371,   371,   372,   372,   373,
     373,   373,   373,   373,   373,   373,   373,   373,   373,   374,
     375,   375,   376,   376,   377,   377,   378,   379,   378,   380,
     378,   381,   378,   382,   378,   383,   378,   384,   378,   385,
     378,   386,   378,   387,   378,   378,   388,   378,   378,   378,
     378,   378,   378,   378,   389,   378,   378,   378,   378,   378,
     390,   378,   378,   391,   378,   378,   392,   378,   393,   378,
     378,   394,   378,   395,   395,   396,   396,   398,   397,   400,
     399,   402,   401,   404,   403,   406,   405,   408,   407,   409,
     409,   409,   409,   409,   409,   409,   409,   410,   410,   410,
     410,   410,   410,   410,   410,   410,   410,   410,   410,   410,
     410,   411,   411,   411,   411,   411,   411,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   413,   413,   413,   413,   413,   413,
     414,   414,   414,   415,   415,   416,   416,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   418,   418,   418,   418,   418,   419,   419,
     420,   420,   421,   421,   421,   421,   422,   422,   422,   422,
     422,   422,   422,   422,   422,   422,   423,   424,   424,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     425,   425,   425,   425,   425,   425,   425,   425,   425,   425,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     427,   427,   428,   429,   430,   431,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   433,   433,   434,   434,   434,   434,   435,
     436,   437,   437,   438,   438,   439,   440,   440,   442,   441,
     443,   441,   444,   441,   445,   441,   446,   441,   447,   448,
     441,   450,   449,   451,   449,   452,   449,   453,   449,   454,
     449,   456,   455,   458,   457,   460,   459,   461,   461,   461,
     461,   461,   461,   461,   461,   461,   461,   461,   462,   462,
     462,   462,   462,   462,   462,   462,   462,   462,   462,   463,
     463,   463,   463,   463,   463,   463,   463,   463,   463,   463,
     464,   465,   466,   467,   467,   467,   468,   469,   470,   471,
     471,   472,   471,   473,   473,   473,   474,   475,   475,   476,
     476,   476,   477,   477,   478,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   480,   481,   481,
     481,   482,   483,   483,   484,   485,   485,   485,   487,   486,
     488,   488,   488,   489,   489,   489,   489,   489,   489,   489,
     489,   489,   489,   489,   489,   490,   490,   490,   490,   491,
     491,   493,   492,   494,   492,   495,   495,   495,   496,   496,
     496,   496,   497,   498,   498,   498,   498,   499,   499,   499,
     499,   500,   501,   501,   501,   501,   501,   502,   502,   503,
     503,   504,   504,   504,   504,   505,   505,   506,   506,   507,
     507,   508,   508,   509,   509,   510,   510,   510,   511,   511,
     511,   512,   512,   512,   513,   513,   513,   514,   514,   515,
     515,   516,   516,   517,   517,   518,   518,   518,   518,   518,
     518,   518,   519,   519,   519,   519,   519,   520,   520,   520,
     520,   520,   520,   520,   520,   520,   520,   520,   520,   521,
     521,   521,   521,   522,   522,   523,   523,   523,   523,   523,
     523,   523,   523
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     3,     0,     0,     4,     4,     4,
       4,     4,     2,     2,     1,    10,    10,    23,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     2,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     2,
       2,     1,     2,     1,     2,     2,     1,     0,     5,     0,
       7,     0,     7,     0,     5,     0,     5,     0,     5,     0,
       3,     0,     3,     0,     3,     1,     0,     3,     1,     1,
       1,     1,     1,     1,     0,     3,     1,     1,     1,     1,
       0,     3,     1,     0,     3,     1,     0,     3,     0,     3,
       1,     0,     5,     3,     3,     1,     1,     0,     5,     0,
       5,     0,     5,     0,    11,     0,    13,     0,    13,     1,
       1,     1,     1,     1,     1,     4,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     8,     6,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     8,     8,     8,    10,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     1,     1,     3,     1,     5,    10,    12,    12,
      10,    10,     8,    10,    10,     8,     8,     6,     8,     6,
       6,     4,     1,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     2,     1,     2,     1,     8,     9,     0,    12,
       0,    12,     0,    12,     0,    12,     0,    12,     0,     0,
      12,     0,    12,     0,    12,     0,    12,     0,    12,     0,
      12,     0,    17,     0,    17,     0,     9,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
      20,    13,    16,     1,     1,     1,     1,     1,     1,     9,
      16,     0,    17,     1,     1,     1,     3,     0,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,    11,    13,
      13,     1,     6,     9,     7,     1,     1,     3,     0,    11,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     2,     0,
       2,     0,     3,     0,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     2,     1,
       1,     1,     2,     1,     1,     1,     1,     2,     1,     2,
       1,     1,     1,     1,     0,     2,     2,     5,     5,     5,
       5,     5,     5,     1,     1,     1,     3,     3,     4,     4,
       3,     3,     1,     3,     1,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 698 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 716 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 717 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 718 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 719 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 721 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3113 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 727 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 732 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3134 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* $@2: %empty  */
#line 742 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3144 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 748 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 754 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 761 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3177 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 768 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 777 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3196 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 779 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 781 "../src/freedreno/ir3/ir3_parser.y"
                                        { info->early_preamble = 1; }
#line 3208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 784 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 786 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 793 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_SY  */
#line 795 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_SS  */
#line 796 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* iflag: T_JP  */
#line 797 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* iflag: T_SAT  */
#line 798 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_RPT  */
#line 799 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_UL  */
#line 800 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_NOP  */
#line 801 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3268 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 54: /* instr: iflags cat5_instr  */
#line 814 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 59: /* label: T_IDENTIFIER ':'  */
#line 820 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 60: /* cat0_src1: '!' T_P0  */
#line 822 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* cat0_src1: T_P0  */
#line 823 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* cat0_src2: '!' T_P0  */
#line 825 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* cat0_src2: T_P0  */
#line 826 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* cat0_immed: '#' integer  */
#line 828 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* cat0_immed: '#' T_IDENTIFIER  */
#line 829 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_instr: T_OP_NOP  */
#line 831 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* $@3: %empty  */
#line 832 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* $@4: %empty  */
#line 833 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* $@5: %empty  */
#line 834 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@6: %empty  */
#line 835 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@7: %empty  */
#line 836 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@8: %empty  */
#line 837 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* $@9: %empty  */
#line 838 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* $@10: %empty  */
#line 839 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@11: %empty  */
#line 840 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* cat0_instr: T_OP_RET  */
#line 841 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 86: /* $@12: %empty  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* cat0_instr: T_OP_END  */
#line 843 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* cat0_instr: T_OP_EMIT  */
#line 844 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_CUT  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_CHMASK  */
#line 846 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* cat0_instr: T_OP_CHSH  */
#line 847 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_FLOW_REV  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* $@13: %empty  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* cat0_instr: T_OP_STKS  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* cat0_instr: T_OP_STKR  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_XSET  */
#line 852 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_XCLR  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* $@14: %empty  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* cat0_instr: T_OP_DBG  */
#line 855 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 103: /* $@15: %empty  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* cat0_instr: T_OP_SHPE  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* $@16: %empty  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* $@17: %empty  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* cat0_instr: T_OP_PREDE  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 111: /* $@18: %empty  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3518 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 117: /* $@19: %empty  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@19 dst_reg  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* $@20: %empty  */
#line 889 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3555 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* $@21: %empty  */
#line 896 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3566 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 123: /* $@22: %empty  */
#line 903 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3572 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 125: /* $@23: %empty  */
#line 905 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3578 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 127: /* $@24: %empty  */
#line 907 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3584 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 137: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 919 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3590 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 920 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3596 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3602 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 922 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3608 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3614 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 924 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3620 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 925 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3626 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 926 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3632 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 927 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3638 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 928 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3644 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_NOT_B  */
#line 929 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3650 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 930 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3656 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_SETRM  */
#line 931 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3662 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 932 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3668 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3674 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3680 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3686 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3692 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3698 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3704 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src: T_OP_ADD_F  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3710 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src: T_OP_MIN_F  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3716 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_MAX_F  */
#line 943 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3722 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MUL_F  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3728 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_ADD_U  */
#line 945 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3734 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_ADD_S  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3740 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_SUB_U  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3746 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_SUB_S  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3752 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_MIN_U  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3758 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_MIN_S  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3764 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MAX_U  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3770 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_MAX_S  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3776 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_AND_B  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3782 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_OR_B  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3788 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_XOR_B  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3794 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3800 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3806 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MULL_U  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3812 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_SHL_B  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3818 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_SHR_B  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3824 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3830 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_BARY_F  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3836 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 3842 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3848 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 965 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3854 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_SHB  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3860 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_MSAD  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3866 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cond: T_LT  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3872 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cond: T_LE  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3878 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cond: T_GT  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3884 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cond: T_GE  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3890 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cond: T_EQ  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3896 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cond: T_NE  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3902 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cat3_dp_signedness: '.' T_MIXED  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 3908 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 3914 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_dp_pack: '.' T_LOW  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 3920 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_dp_pack: '.' T_HIGH  */
#line 984 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 3926 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_opc: T_OP_MAD_U16  */
#line 986 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 3932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_opc: T_OP_MADSH_U16  */
#line 987 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 3938 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_MAD_S16  */
#line 988 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 3944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_opc: T_OP_MADSH_M16  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 3950 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_opc: T_OP_MAD_U24  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 3956 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_opc: T_OP_MAD_S24  */
#line 991 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 3962 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_opc: T_OP_MAD_F16  */
#line 992 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 3968 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_F32  */
#line 993 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 3974 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_SEL_B16  */
#line 994 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 3980 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_SEL_B32  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 3986 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_SEL_S16  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 3992 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_SEL_S32  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 3998 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_SEL_F16  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4004 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_SEL_F32  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4010 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_SAD_S16  */
#line 1000 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4016 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SAD_S32  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4022 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1003 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4028 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1004 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4034 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1007 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_wmm: T_OP_WMM  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_dp: T_OP_DP2ACC  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_dp: T_OP_DP4ACC  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat4_opc: T_OP_RCP  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat4_opc: T_OP_RSQ  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat4_opc: T_OP_LOG2  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat4_opc: T_OP_EXP2  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat4_opc: T_OP_SIN  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat4_opc: T_OP_COS  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat4_opc: T_OP_SQRT  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_HRSQ  */
#line 1027 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_HLOG2  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_HEXP2  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1033 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4142 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4148 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc: T_OP_ISAM  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 4154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc: T_OP_ISAML  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4160 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_ISAMM  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_opc: T_OP_SAM  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4172 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_opc: T_OP_SAMB  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4178 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc: T_OP_SAML  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4184 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc: T_OP_SAMGQ  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc: T_OP_GETLOD  */
#line 1043 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4196 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_CONV  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_CONVM  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_GETSIZE  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_GETBUF  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_GETPOS  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_GETINFO  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_DSX  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_DSY  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_GATHER4R  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_GATHER4G  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GATHER4B  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GATHER4A  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4268 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_SAMGP0  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_SAMGP1  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_SAMGP2  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_SAMGP3  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_RGETPOS  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_RGETINFO  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_BRCST_A  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_flag: '.' T_3D  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_flag: '.' 'a'  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_flag: '.' 'o'  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_flag: '.' 'p'  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_flag: '.' 's'  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_flag: '.' T_S2EN  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_flag: '.' T_UNIFORM  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' T_BASE  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' T_W  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* cat5_samp: T_SAMP  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat5_tex: T_TEX  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_type: '(' type ')'  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_a1: src_reg  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 302: /* cat5_instr: T_OP_TCINV  */
#line 1102 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 303: /* cat6_typed: '.' T_UNTYPED  */
#line 1104 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 304: /* cat6_typed: '.' T_TYPED  */
#line 1105 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 305: /* cat6_dim: '.' T_1D  */
#line 1107 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 306: /* cat6_dim: '.' T_2D  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* cat6_dim: '.' T_3D  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat6_dim: '.' T_4D  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat6_type: '.' type  */
#line 1112 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_imm_offset: offset  */
#line 1113 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_dst_offset: offset  */
#line 1116 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 315: /* cat6_immed: integer  */
#line 1119 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 316: /* cat6_stg_ldg_a6xx_offset: '+' '(' src offset ')' '<' '<' integer  */
#line 1122 "../src/freedreno/ir3/ir3_parser.y"
                                                           {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                    }
#line 4494 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_stg_ldg_a6xx_offset: '+' src '<' '<' integer offset '<' '<' integer  */
#line 1127 "../src/freedreno/ir3/ir3_parser.y"
                                                                  {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                    }
#line 4504 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 318: /* $@25: %empty  */
#line 1133 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4510 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* $@26: %empty  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4516 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* $@27: %empty  */
#line 1135 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4522 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* $@28: %empty  */
#line 1136 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4528 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 326: /* $@29: %empty  */
#line 1137 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4534 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* $@30: %empty  */
#line 1138 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4540 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* $@31: %empty  */
#line 1138 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4548 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 331: /* $@32: %empty  */
#line 1142 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4554 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* $@33: %empty  */
#line 1143 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4560 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* $@34: %empty  */
#line 1144 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4566 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 337: /* $@35: %empty  */
#line 1145 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4572 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 339: /* $@36: %empty  */
#line 1146 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4578 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* $@37: %empty  */
#line 1148 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4584 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 343: /* $@38: %empty  */
#line 1149 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4590 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 345: /* $@39: %empty  */
#line 1151 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4596 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1153 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4602 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 348: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4608 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1155 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4614 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 350: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4620 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4626 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4632 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 353: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1159 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4638 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4644 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1161 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4650 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4656 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4662 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4668 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4674 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1167 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4680 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1168 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4686 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4692 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1170 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4698 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4704 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4710 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4716 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4722 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4728 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4734 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4740 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1179 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4746 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4752 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1181 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4758 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1182 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4764 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4770 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1184 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4776 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1185 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 4782 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 4788 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1187 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 4794 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4800 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 387: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1201 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4806 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 388: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1202 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4812 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* $@40: %empty  */
#line 1206 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4818 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 393: /* cat6_id_opc: T_OP_GETSPID  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4824 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* cat6_id_opc: T_OP_GETWID  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4830 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 4836 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* cat6_bindless_base: '.' T_BASE  */
#line 1216 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4842 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1220 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4848 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 403: /* cat6_reg_or_immed: integer  */
#line 1223 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4854 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 404: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1225 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4860 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1227 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 4866 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 406: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1228 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 4872 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 407: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1229 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 4878 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1230 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 4884 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 409: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1231 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 4890 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1232 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 4896 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1233 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 4902 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1234 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 4908 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1235 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 4914 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 4920 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1237 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 4926 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1238 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 4932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1240 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 4938 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1243 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 4944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1244 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 4950 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1246 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 4956 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 422: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1250 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 4962 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1251 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 4968 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1253 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 4978 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 425: /* stc_dst: integer  */
#line 1259 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4984 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* stc_dst: T_A1  */
#line 1260 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 4990 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* stc_dst: T_A1 '+' integer  */
#line 1261 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 4996 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* $@41: %empty  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                   { new_instr(OPC_STC); }
#line 5002 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* cat6_todo: T_OP_G2L  */
#line 1265 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5008 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* cat6_todo: T_OP_L2G  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5014 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* cat6_todo: T_OP_RESFMT  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5020 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 445: /* cat7_scope: '.' 'w'  */
#line 1282 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5026 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 446: /* cat7_scope: '.' 'r'  */
#line 1283 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5032 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 447: /* cat7_scope: '.' 'l'  */
#line 1284 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5038 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 448: /* cat7_scope: '.' 'g'  */
#line 1285 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5044 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 451: /* $@42: %empty  */
#line 1290 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5050 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 453: /* $@43: %empty  */
#line 1291 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5056 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 455: /* cat7_data_cache: T_OP_DCCLN  */
#line 1293 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5062 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 456: /* cat7_data_cache: T_OP_DCINV  */
#line 1294 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5068 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 457: /* cat7_data_cache: T_OP_DCFLU  */
#line 1295 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5074 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 460: /* cat7_instr: T_OP_SLEEP  */
#line 1299 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5080 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 461: /* cat7_instr: T_OP_ICINV  */
#line 1300 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5086 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* raw_instr: T_RAW  */
#line 1302 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5092 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 463: /* src: T_REGISTER  */
#line 1304 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5098 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 464: /* src: T_A0  */
#line 1305 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5104 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 465: /* src: T_A1  */
#line 1306 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5110 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* src: T_P0  */
#line 1307 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 5116 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 467: /* dst: T_REGISTER  */
#line 1309 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5122 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 468: /* dst: T_A0  */
#line 1310 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5128 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 469: /* dst: T_A1  */
#line 1311 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5134 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* dst: T_P0  */
#line 1312 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 5140 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* const: T_CONSTANT  */
#line 1314 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5146 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 472: /* dst_reg_flag: T_EVEN  */
#line 1316 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5152 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 473: /* dst_reg_flag: T_POS_INFINITY  */
#line 1317 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5158 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1318 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5164 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* dst_reg_flag: T_EI  */
#line 1319 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5170 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* dst_reg_flag: T_WRMASK  */
#line 1320 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5176 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 479: /* dst_reg: dst  */
#line 1326 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5182 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* dst_reg: dst_reg_flags dst  */
#line 1327 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5188 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* src_reg_flag: T_ABSNEG  */
#line 1329 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5194 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* src_reg_flag: T_NEG  */
#line 1330 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5200 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 483: /* src_reg_flag: T_ABS  */
#line 1331 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5206 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* src_reg_flag: T_R  */
#line 1332 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5212 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 504: /* offset: %empty  */
#line 1361 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5218 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 505: /* offset: '+' integer  */
#line 1362 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5224 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 506: /* offset: '-' integer  */
#line 1363 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5230 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 507: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1365 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5236 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 508: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1366 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5242 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 509: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1368 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5248 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 510: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1369 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5254 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 511: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1371 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5260 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 512: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1372 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5266 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 515: /* immediate_cat1: integer  */
#line 1381 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5272 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 516: /* immediate_cat1: '(' integer ')'  */
#line 1382 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5278 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 517: /* immediate_cat1: '(' float ')'  */
#line 1383 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5284 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 518: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1384 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5290 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 519: /* immediate_cat1: 'h' '(' float ')'  */
#line 1385 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5296 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 520: /* immediate_cat1: '(' T_NAN ')'  */
#line 1386 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5302 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 521: /* immediate_cat1: '(' T_INF ')'  */
#line 1387 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5308 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 522: /* immediate: integer  */
#line 1389 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5314 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 523: /* immediate: '(' integer ')'  */
#line 1390 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5320 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 524: /* immediate: flut_immed  */
#line 1391 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5326 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 525: /* immediate: 'h' '(' integer ')'  */
#line 1392 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5332 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 526: /* immediate: 'h' flut_immed  */
#line 1393 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5338 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 539: /* integer: T_INT  */
#line 1409 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5344 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* integer: '-' T_INT  */
#line 1410 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5350 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 541: /* integer: T_HEX  */
#line 1411 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5356 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 542: /* integer: '-' T_HEX  */
#line 1412 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5362 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 543: /* float: T_FLOAT  */
#line 1414 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5368 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 544: /* float: '-' T_FLOAT  */
#line 1415 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5374 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 545: /* type: T_TYPE_F16  */
#line 1417 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 5380 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 546: /* type: T_TYPE_F32  */
#line 1418 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 5386 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 547: /* type: T_TYPE_U16  */
#line 1419 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 5392 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 548: /* type: T_TYPE_U32  */
#line 1420 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 5398 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 549: /* type: T_TYPE_S16  */
#line 1421 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 5404 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 550: /* type: T_TYPE_S32  */
#line 1422 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 5410 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 551: /* type: T_TYPE_U8  */
#line 1423 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 5416 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 552: /* type: T_TYPE_S8  */
#line 1424 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 5422 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5426 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

